// apachemod/editscript.cc
// This file is part of Anyterm; see http://anyterm.org/
// (C) 2005 Philip Endecott

// This is version $Name: V1-1-4 $
//   (if there is no version (e.g. V0-1) mentioned in the previous line,
//    this is probably a snapshot from between "official" releases.)

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


#include "editscript.h"

#include "diff.hh"

#include <string>

using namespace std;


string make_editscript(string o, string n)
{
  DiffAlgo::string_fragment_seq e;

  DiffAlgo::string_diff(o,n,e);

  std::string editscript;

  for ( DiffAlgo::string_fragment_seq::const_iterator i = e.begin();
	i != e.end(); ++i ) {
    char len[10];
    // The following line generates a warning on 64-bit architectures
    snprintf(len,sizeof(len),"%d",i->second.length());
    switch (i->first) {
    case DiffAlgo::from_a:
      editscript += std::string("d") + len + ':';
      break;
    case DiffAlgo::from_b:
      editscript += std::string("i") + len + ':' + i->second;
      break;
    case DiffAlgo::common:
      editscript += std::string("k") + len + ':';
      break;
    }
  }

  return editscript;
}


