// apachemod/errors.h
// This file is part of Anyterm; see http://anyterm.org/
// (C) 2005 Philip Endecott

// This is version $Name: V1-1-4 $
//   (if there is no version (e.g. V0-1) mentioned in the previous line,
//    this is probably a snapshot from between "official" releases.)

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


// Exception classes to indicate errors

#ifndef errors_h
#define errors_h

#include <string>


class Error {
 private:
  std::string msg;

 public:
  Error(std::string m): msg(m) {};
  std::string get_msg(void) const {return msg;}
};


class SysError: public Error {
 public:
  SysError(std::string m): Error(m+": "+strerror(errno)) {};
};





#endif
