// apachemod/fifo.h
// This file is part of Anyterm; see http://anyterm.org/
// (C) 2005 Philip Endecott

// This is version $Name: V1-1-4 $
//   (if there is no version (e.g. V0-1) mentioned in the previous line,
//    this is probably a snapshot from between "official" releases.)

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


// A simple FIFO queue type, used to send keystrokes to the backend
// process.  This relies on changes to the input and output pointers
// being atomic to guarantee correct behaviour between multiple
// processes.

#ifndef fifo_h
#define fifo_h


class Fifo {
 private:
  char data[128];
  unsigned int ipos; /* Free space for next input character */
  unsigned int opos; /* Space occupied by next output character */

 public:
  Fifo(void);
  bool empty(void) volatile;
  bool full(void) volatile;
  int push(const char* d, int n) volatile;
  int pop(char* d, int n) volatile;
};


#endif
