// browser/anyterm.js
// This file is part of Anyterm; see http://anyterm.org/
// (C) 2005 Philip Endecott

// This is version $Name: V1-1-4 $
//   (if there is no version (e.g. V0-1) mentioned in the previous line,
//    this is probably a snapshot from between "official" releases.)

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


var frame;
var term;
var open=false;
var session;

var post_method="POST";

// Random sequence numbers are needed to prevent Opera from caching
// replies

var is_opera = navigator.userAgent.toLowerCase().indexOf("opera") != -1;
if (is_opera) {
  post_method="GET";
}

var seqnum_val=Math.round(Math.random()*100000);
function cachebust() {
  if (is_opera) {
    seqnum_val++;
    return "&x="+seqnum_val;
  } else {
    return "";
  }
}


// Asynchronous and Synchronous XmlHttpRequest wrappers

// AsyncLoader is a class; an instance specifies a callback function.
// Call load to get something and the callback is invoked with the
// returned document.

function AsyncLoader(cb) {
  this.callback = cb;
  this.load =  function (url) {
    var xmlhttp = new XMLHttpRequest();
    xmlhttp.open(post_method, url, true);
    var cbk = this.callback;
    xmlhttp.onreadystatechange = function () {
      if (xmlhttp.readyState==4) {
	if (xmlhttp.status!=200) {
	  alert("Server returned status code "+xmlhttp.status+":\n"+xmlhttp.responseText);
	  cbk(null);
	} else {
	  cbk(xmlhttp.responseXML);
	}
      }
    }
    xmlhttp.send(null);
  }
}


// Synchronous loader is a simple function

function sync_load(url) {
  var xmlhttp = new XMLHttpRequest();
  xmlhttp.open(post_method, url, false);
  xmlhttp.send(null);
  if (xmlhttp.status!=200) {
    alert("Server returned status code "+xmlhttp.status+":\n"+xmlhttp.responseText);
    return null;
  }
  return xmlhttp.responseXML;
}


// Receive channel:

var rcv_loader;

var disp="";

function display(n) {

  //term.innerHTML=Sarissa.serialize(n);
  //alert(Sarissa.serialize(n));

  var edscr = getTextContent(n);
  //alert(edscr);

  var ndisp="";
  
  while (edscr!="") {
    var cmd=edscr.substr(0,1);
    edscr=edscr.substr(1);
    var cp=edscr.indexOf(":");
    var num=edscr.substr(0,cp);
    //alert("cmd="+cmd+" num="+num);
    edscr=edscr.substr(cp+1);
    if (cmd=="d") {
      disp=disp.substr(num);
    } else if (cmd=="k") {
      ndisp+=disp.substr(0,num);
      disp=disp.substr(num);
    } else if (cmd=="i") {
      if (edscr.length<num) {
	alert("edit script ended early; expecting "+num+" but got only "+edscr.length);
      }
      ndisp+=edscr.substr(0,num);
      edscr=edscr.substr(num);
    }
  }

  disp=ndisp;

  var h="";
  while (ndisp!="") {
    var bspos=ndisp.indexOf('\\');
    if (bspos==-1) {
      h+=ndisp;
      break;
    }
    h+=ndisp.substr(0,bspos);
    ndisp=ndisp.substr(bspos+1);
    if (ndisp.substr(0,1)=='n') {
      h+="<br>";
    } else {
      h+=ndisp.substr(0,1);
    }
    ndisp=ndisp.substr(1);
  }

  term.innerHTML=h;
  //  alert(h);
}


function get() {
  //alert("get");
  rcv_loader.load("anyterm-module?rcv&s="+session+cachebust());
}

function rcv(doc) {
  // Called asynchronously when the received document has returned
  // from the server.
  //alert(Sarissa.serialize(doc));

  if (!open) {
    return;
  }

  var root = get_response_root(doc);
  if (!root) {
    return;
  } else if (root.tagName=="op") {
    display(root);
    get();
  } else {
    alert("Unrecognised response: "+root.tagName);
  }
}

rcv_loader = new AsyncLoader(rcv);


// Transmit channel:

var kb_buf="";
var send_loader;
var send_in_progress=false;

function send() {
  send_in_progress=true;
  send_loader.load("anyterm-module?send&s="+session+cachebust()+"&k="+encodeURIComponent(kb_buf));
  kb_buf="";
}

function send_done(doc) {
  send_in_progress=false;
  // should check for errors
  if (kb_buf!="") {
    send();
  }
}

send_loader = new AsyncLoader(send_done);


function maybe_send() {
  if (!send_in_progress && open && kb_buf!="") {
    send();
  }
}


function process_key(k) {
//   alert("key="+k);
//   return;
  kb_buf+=k;
  maybe_send();
}


function esc_seq(s) {
  return String.fromCharCode(27)+"["+s;
}


function key_ev_stop(ev) {
  ev.cancelBubble=true;
  if (ev.stopPropagation) ev.stopPropagation();
  if (ev.preventDefault)  ev.preventDefault();
}


function keypress(ev) {
  if (!ev) var ev=window.event;

  if (ev.ctrlKey
      || (ev.which==0)
      || (ev.keyCode==8)) {
    key_ev_stop(ev);
    return false;
  }

  var kc;
  if (ev.keyCode) kc=ev.keyCode;
  if (ev.which)   kc=ev.which;
  
  var k=String.fromCharCode(kc);

//     alert("keypress keyCode="+ev.keyCode+" which="+ev.which+
//   	" shiftKey="+ev.shiftKey+" ctrlKey="+ev.ctrlKey+" altKey="+ev.altKey);

  process_key(k);

  key_ev_stop(ev);
  return false;
}


function keydown(ev) {
  if (!ev) var ev=window.event;

  //  alert("keydown keyCode="+ev.keyCode+" which="+ev.which+
  // 	" shiftKey="+ev.shiftKey+" ctrlKey="+ev.ctrlKey+" altKey="+ev.altKey);

  var k;

  var kc=ev.keyCode;
  if (kc==33) k=esc_seq("5~");       // PgUp
  else if (kc==34) k=esc_seq("6~");  // PgDn
  else if (kc==35) k=esc_seq("4~");  // End
  else if (kc==36) k=esc_seq("1~");  // Home
  else if (kc==37) k=esc_seq("D");   // Left
  else if (kc==38) k=esc_seq("A");   // Up
  else if (kc==39) k=esc_seq("C");   // Right
  else if (kc==40) k=esc_seq("B");   // Down
  else if (kc==45) k=esc_seq("2~");  // Ins
  else if (kc==46) k=esc_seq("3~");  // Del
  else if (kc==27) k=String.fromCharCode(27); // Escape
  else if (kc==9)  k=String.fromCharCode(9);  // Tab
  else if (kc==8)  k=String.fromCharCode(8);  // Backspace
  else if (kc==112) k=esc_seq("[A");  // F1
  else if (kc==113) k=esc_seq("[B");  // F2
  else if (kc==114) k=esc_seq("[C");  // F3
  else if (kc==115) k=esc_seq("[D");  // F4
  else if (kc==116) k=esc_seq("[E");  // F5
  else if (kc==117) k=esc_seq("17~"); // F6
  else if (kc==118) k=esc_seq("18~"); // F7
  else if (kc==119) k=esc_seq("19~"); // F8
  else if (kc==120) k=esc_seq("20~"); // F9
  else if (kc==121) k=esc_seq("21~"); // F10

  else {
  
    if (!ev.ctrlKey || ev.keyCode==17) {
      key_ev_stop(ev);
      return;
    }

    k=String.fromCharCode(kc-64);
  }

//   alert("keydown keyCode="+ev.keyCode+" which="+ev.which+
// 	" shiftKey="+ev.shiftKey+" ctrlKey="+ev.ctrlKey+" altKey="+ev.altKey);

  process_key(k);

  key_ev_stop(ev);
  return false;
}


// Misc:



function get_response_root(d) {
  if (!d) {
    return null;
  }
  if (d.parseError && d.parseError!=0) {
    alert("Parse error: "+Sarissa.getParseErrorText(d));
    return null;
  }
  var n = d.firstChild;
  while (n.nodeType!=1) {
    n = n.nextSibling;
    if (!n) {
      alert("Can't find root node");
    }
  }
  if (!n) {
    alert("Error: no data in response");
    return null;
  }
  if (n.tagName=="error") {
    alert("Error: "+n.firstChild.data);
    return null;
  }
  return n;
}

function getTextContent(n) {
  // Note that long text nodes may be broken up into a series of
  // shorter ones!
  var t="";
  var i=n.firstChild;
  while (i) {
    t+=i.data;
    i=i.nextSibling;
  }
  return t;
}


// Open, close and initialisation:

function open_term(rows,cols) {
  var d = sync_load("anyterm-module?open&rows="+rows+"&cols="+cols+cachebust());
  var root=get_response_root(d);
  if (!root) {
    return null;
  } else if (root.tagName=="open") {
    open=true;
    session=root.getAttribute("s");
    //alert("Session "+session+" opened");
  } else {
    alert("Unrecognised response (root.tagName='"+root.tagName+"'): "+Sarissa.serialize(d));
  }
}

function close_term() {
  if (!open) {
    alert("Connection is not open");
    return;
  }
  open=false;
  var d = sync_load("anyterm-module?close&s="+session+cachebust());
  var root=get_response_root(d);
  if (!root) {
    return null;
  }
  if (root.tagName!="close") {
    alert("Unrecognised response: "+root.tagName);
  }
  document.onkeypress=null;
  document.onkeydown=null;
  window.onbeforeunload=null;
  var e;
  while (e=frame.firstChild) {
    frame.removeChild(e);
  }
  frame.className="";
}

function substitute_variables(s) {
  var version_raw="$Name: V1-1-4 $";
  var version=version_raw.substr(8).replace(/-/g,'.');
  version=version.substr(0,version.indexOf("$")-1);
  if (version!="") {
    version="-"+version;
  }
  var hostname=document.location.host;
  return s.replace(/%v/g,version).replace(/%h/g,hostname);
}

function create_term(elem_id,title,rows,cols) {
  if (open) {
    alert("Terminal is already open");
    return;
  }
  title=substitute_variables(title);
  frame=document.getElementById(elem_id);
  if (!frame) {
    alert("There is no element named '"+elem_id+"' in which to build a terminal");
    return;
  }
  frame.className="termframe";
  var title_p=document.createElement("P");
  var title_t=document.createTextNode(title+" ");
  title_p.appendChild(title_t);
  var closebutton=document.createElement("A");
  var closebutton_t=document.createTextNode("[close]");
  closebutton.appendChild(closebutton_t);
  title_p.appendChild(closebutton);
  frame.appendChild(title_p);
  term=document.createElement("PRE");
  frame.appendChild(term);
  term.className="term";
  var termbody=document.createTextNode("");
  term.appendChild(termbody);
  closebutton.onclick=close_term;
  document.onkeypress=keypress;
  document.onkeydown=keydown;
  open_term(rows,cols);
  if (open) {
    window.onbeforeunload=warn_unload;
    get();
    maybe_send();
  }
}


function warn_unload() {
  if (open) {
    return "Leaving this page will close the terminal.";
  }
}


